<template>
  <div class="time-line__element-image-wrapper">
    <div class="time-line__element-image" :class="'time-line__element-image_' + size">
      <img
        :class="[
							{'time-line__local-img': imageUrl},
							{'time-line__online-img': !imageUrl}
						]"
        v-bind:alt="altText"
        v-bind:src="src"
      >
    </div>
  </div>
</template>

<script>
export default {
  name: "Picture",
  props: {
    imageUrl: String,
    priority: Number,
    altText: String
  },
  computed: {
    src: function() {
      return this.imageUrl
        ? this.imageUrl
        : `https://avatars.dicebear.com/v2/identicon/:${this.altText +
            this.priority}.svg`;
    },
    size: function() {
      switch (this.priority) {
        case 0:
          return "sm";
        case 1:
          return "md";
        default:
          return "lg";
      }
    }
  }
};
</script>

<style scoped lang="scss">
@import "~/assets/scss/_variables.scss";
@import "~/assets/scss/_mixins.scss";

$point-size: (
  lg: $max-time-line-element-image-size,
  md: $max-time-line-element-image-size -
    $difference-time-line-element-image-size,
  sm: $max-time-line-element-image-size -
    $difference-time-line-element-image-size  * 2
);

.time-line {
  &__element-image-wrapper {
		flex-shrink: 0;
    position: relative;
    width: $max-time-line-element-image-size;
    height: $max-time-line-element-image-size;
    display: flex;
    align-items: center;
    justify-content: center;
    @include respond-to(sm) {
    }
  }
  &__element-image {
    border-radius: 100%;
    background: #ffffff;
    box-shadow: 1px 1px 2px 0px rgba(0, 0, 0, 0.3);
    border: 5px solid #ffffff;
    @each $type, $size in $point-size {
      &_#{$type} {
        width: $size;
        height: $size;
        @include respond-to(sm) {
          margin-left: 0px;
        }
      }
    }
    @include respond-to(sm) {
      border: 2px solid #ffffff;
    }
    @include respond-to(md) {
      border: 3px solid #ffffff;
    }
    @include respond-to(lg) {
      border: 4px solid #ffffff;
    }
  }

  &__local-img {
    width: 100%;
    height: 100%;
    border-radius: 100%;
  }
  &__online-img {
    width: calc(100% - 20px);
    height: calc(100% - 20px);
    margin: 10px;
  }
}
</style>